class Platno {
  constructor(idKontejneru, idPlatna, sirka, vyska, ukazLegendu,typ_pr) {
    this.idPlatna = idPlatna;
    this.typ_pr = typ_pr;
    this.ukazLegendu = ukazLegendu;
    this.idKontejneru = idKontejneru;
    this.kontejnerPlatna = document.getElementById(this.idKontejneru);
    this.kontejnerPlatna.setAttribute("style", "position: relative; width: 650px; height: 500px; margin: 0 auto;");
    this.elementPlatna = document.getElementById(this.idPlatna);
    this.elementPlatna.width =  this.kontejnerPlatna.offsetWidth;//sirka;
    this.elementPlatna.height = this.kontejnerPlatna.offsetHeight;//vyska;
    this.obsahPlatna = this.elementPlatna.getContext("2d");
  }

  vycistiPlatno(){
    this.obsahPlatna.clearRect(0, 0, this.elementPlatna.width, this.elementPlatna.height);
    this.obsahPlatna.beginPath();
  }
  skryjPlatno(){
    this.elementPlatna.width = 0;
    this.elementPlatna.height = 0;
    this.elementPlatna.style.border = "none";
  }

  vykresliCaru(startX, startY, konecX, konecY){
    this.obsahPlatna.beginPath();
    this.obsahPlatna.moveTo(startX,startY);
    this.obsahPlatna.lineTo(konecX,konecY);
    this.obsahPlatna.stroke();
  }

  vykresliKrivku(polomer, startUhel, konecUhel){
    this.obsahPlatna.beginPath();
    this.stredX = this.elementPlatna.width/2;
    this.stredY = this.elementPlatna.height/2;
    this.obsahPlatna.arc(this.stredX, this.stredY, polomer, startUhel, konecUhel);
    this.obsahPlatna.stroke();
  }

  vykresliVysec(polomer, startUhel, konecUhel, barva){
    this.stredX = this.elementPlatna.width/2;
    this.stredY = this.elementPlatna.height/2;
    this.obsahPlatna.fillStyle = barva;
    this.obsahPlatna.beginPath();
    this.obsahPlatna.moveTo(this.stredX,this.stredY);
    this.obsahPlatna.arc(this.stredX, this.stredY, polomer, startUhel, konecUhel);
    this.obsahPlatna.closePath();
    this.obsahPlatna.fill();
  }
}

class KruhovyGraf extends Platno {
  constructor(idKontejneru, idPlatna, sirka, vyska, polomer, ukazPlatno,typ_pr) {
    super(idKontejneru, idPlatna, sirka+sirka/15, vyska+vyska/3, ukazPlatno,typ_pr);
    this.polomer = polomer;
    this.sirka = sirka;
    this.vyska = vyska;
    this.stredX = this.elementPlatna.width/2.8;// hodnoty větší než 2.0 = centrování k levému okraji
    this.stredY = this.elementPlatna.height/1.8;// hodnoty menší než 2.0 = centrování k dolnímu okraji

  }

  vykresliVysece(){
    this.obsahPlatna.fillStyle = this.vysec.barva;
    this.obsahPlatna.beginPath();
    this.obsahPlatna.moveTo(this.stredX, this.stredY);
    this.obsahPlatna.arc(this.stredX, this.stredY, this.polomer, this.startVysec, this.konecVysec, false);
    this.obsahPlatna.lineTo(this.stredX, this.stredY);
    this.obsahPlatna.closePath();
    this.obsahPlatna.strokeStyle = "#FFFFFF";
    this.obsahPlatna.fill();
    this.obsahPlatna.lineWidth = 3;
    this.obsahPlatna.lineCap = 'round';
    this.obsahPlatna.stroke();
  }

  vykresliPopisky(){
    this.rozdilKruh = this.konecVysec - this.startVysec;
    this.popisekPozX = this.stredX + Math.sin(this.startVysec + Math.PI/2 + this.rozdilKruh/2) * this.polomer * 0.6;
    this.popisekPozY = this.stredY - Math.cos(this.startVysec + Math.PI/2 + this.rozdilKruh/2) * this.polomer * 0.6;
    this.obsahPlatna.textAlign = 'center';
    this.obsahPlatna.font = 'bold 13pt Calibri';
    this.obsahPlatna.fillStyle = 'black';
    this.obsahPlatna.fillText(this.popisek, this.popisekPozX, this.popisekPozY);
  }

  vytvorSeznamy(idSeznam, polozky, iterace, typ_pr){
    this.rozdilKruh = this.konecVysec - this.startVysec;
    this.seznamPozX = this.stredX + Math.sin(this.startVysec + Math.PI/2 + this.rozdilKruh/2) * this.polomer * 0.6;
    this.seznamPozY = this.stredY - Math.cos(this.startVysec + Math.PI/2 + this.rozdilKruh/2) * this.polomer * 0.6;

    this.seznam = document.createElement("SELECT");
    this.seznam.setAttribute("id", idSeznam+""+typ_pr);
    this.seznam.setAttribute("data-value",polozky[iterace].hodnota);
    this.seznam.setAttribute("style", "position: absolute; width: 40px; height: 25px; z-index: 50; left: "+(this.seznamPozX-17)+"px; top: "+(this.seznamPozY-13)+"px; font-size: 18px;");
    this.kontejnerPlatna.appendChild(this.seznam);
    this.poleHodnot = [""];
    var tplHodnoty = [];
    for (let i = 0; i != polozky.length; i++) {
      tplHodnoty.push(polozky[i].hodnota);
    }
    tplHodnoty.sort(function (a, b) {
      return a - b;
    });
    for (let i = 0; i != polozky.length; i++){
      this.poleHodnot.push(tplHodnoty[i]);
    }

    for (let i = 0; i != this.poleHodnot.length; i++){
      this.polozkaSeznam = document.createElement("option");
      this.polozkaSeznam.setAttribute("value", this.poleHodnot[i]);
      this.hodnotaSeznam = document.createTextNode(this.poleHodnot[i]);
      this.polozkaSeznam.appendChild(this.hodnotaSeznam);
      this.seznam.appendChild(this.polozkaSeznam);
      if(i==0){
        this.polozkaSeznam.disabled = true;
        this.polozkaSeznam.hidden = true;            
      }
    }
  }
  //ukazLegendu == true -> vypise ji do spanu
  //ukazLegendu == false -> vypise selecty
  vytvorLegendu(polozky,ukazLegendu,typ_pr){
    this.legenda = document.createElement("div");
    this.legenda.setAttribute("id", "leg"+typ_pr);
    this.sirkaLegendy = this.sirka-(this.sirka/1.4);
    this.vyskaLegendy = this.vyska-(this.vyska/1.7);
    this.legenda.setAttribute("style", "position: absolute; width: "+this.sirkaLegendy+"px; height: "+this.vyskaLegendy+"px; z-index: 50; right: 0; bottom: 10px; top: 250px; margin: 0 10px 0 0;"); // left: "+(this.seznamPozX-17)+"px; top: "+(this.seznamPozY-13)+"px;");
    this.kontejnerPlatna.appendChild(this.legenda);

    this.polePolozek = [];
    this.poleBarev = [];
    this.poleSeznamLegendy = [];
    for (let i = 0; i != polozky.length; i++){
      this.polePolozek.push(polozky[i].popisek);
      this.poleSeznamLegendy.push(polozky[i].popisek);
      this.poleBarev.push(polozky[i].barva);
    }

    this.velikostPolePolozek = this.polePolozek.length;
    this.velikostPoleBarev = this.poleBarev.length;

    for (var i = this.velikostPolePolozek-1; i >=0; i--) {

      this.indexPolozky = Math.floor(Math.random() * this.velikostPolePolozek);
        this.indexBarvy = this.indexPolozky;

        this.velikostPolePolozek--;
        this.velikostPoleBarev--;
        this.tempPolozky = this.polePolozek[this.velikostPolePolozek];
        this.tempBarvy = this.poleBarev[this.velikostPoleBarev];
      //alert(this.poleBarev);
        this.polePolozek[this.velikostPolePolozek] = this.polePolozek[this.indexPolozky];
        this.poleBarev[this.velikostPoleBarev] = this.poleBarev[this.indexBarvy];
        this.polePolozek[this.indexPolozky] = this.tempPolozky;
        this.poleBarev[this.indexBarvy] = this.tempBarvy;
      //alert(this.poleBarev[this.indexBarvy]);
    }

    this.polePolozek.unshift("");
    this.poleSeznamLegendy.sort();
    this.poleSeznamLegendy.unshift("");
    //alert(this.poleSeznamLegendy);

    for (let i = 0; i != this.polePolozek.length-1; i++){
      this.kontejnerPolozky = document.createElement("div");
      this.kontejnerPolozky.setAttribute("data-value",this.polePolozek[i+1]);
      this.kontejnerPolozky.setAttribute("style", "margin-top: 8px; display: flex");
      this.legenda.appendChild(this.kontejnerPolozky);
      this.barvaPolozky = document.createElement("div");
      this.barvaPolozky.setAttribute("class",this.poleBarev[i]);
      this.barvaPolozky.setAttribute("data-value",this.poleBarev[i]);
      this.barvaPolozky.setAttribute("style","background-color: "+this.poleBarev[i]+"; height: "+(this.vyskaLegendy/(this.polePolozek.length+1))+"px; width: "+(this.sirkaLegendy/(this.polePolozek.length+1))+"px; margin: 0 5px 0 0");
      this.kontejnerPolozky.appendChild(this.barvaPolozky);
      if(ukazLegendu == false){
        this.seznam = document.createElement("SELECT");
        this.seznam.setAttribute("class", this.poleBarev[i]);
        this.seznam.setAttribute("style","flex-grow: 1; font-family: Calibri, sans-serif; font-size: 18px;");
        this.kontejnerPolozky.appendChild(this.seznam);
        //sort
        //this.poleSeznamLegendy.sort();
        for (let i = 0; i != this.poleSeznamLegendy.length; i++){
          this.polozka = document.createElement("option");
          this.polozka.setAttribute("value", this.poleSeznamLegendy[i]);
          this.seznam.appendChild(this.polozka);
          this.hodnota = document.createTextNode(this.poleSeznamLegendy[i]);
          if(i==0){
            this.polozka.disabled = true;
            this.polozka.hidden = true;            
          }
          this.polozka.appendChild(this.hodnota);
        }
      }else{
        this.seznam = document.createElement("span");
        this.seznam.setAttribute("class", this.poleBarev[i]);
        this.seznam.appendChild(document.createTextNode(this.polePolozek[i+1]));
        this.seznam.setAttribute("style","flex-grow: 1; font-family: Calibri, sans-serif; font-size: 18px;");
        this.kontejnerPolozky.appendChild(this.seznam);
      }
    }
  }

  vykresliNadpis(nadpis){
    this.obsahPlatna.textAlign = 'center';
    this.obsahPlatna.font = 'bold 22pt Calibri';
    this.obsahPlatna.fillStyle = 'black';
    this.obsahPlatna.fillText(nadpis, this.elementPlatna.width/2, this.elementPlatna.height/10);
  }

  vykresli(minHodin, maxHodin, id_zadani){
    this.soucetHodnot = 0;
    const data = new Data(minHodin, maxHodin);
    data.vypisZadani(0, 'matematika',id_zadani);
    data.vypisZadani(1, 'cestina',id_zadani);
    data.vypisZadani(2, 'prirodopis',id_zadani);
    data.vypisZadani(3, 'telocvik',id_zadani);
    data.vypisSumaHodin('sumahodin',id_zadani);
    for (let i = 0; i != data.polozky.length; i++){
      this.vysec = data.polozky[i];
      this.soucetHodnot += this.vysec.hodnota;
    }

    this.soucetVyseci = 0;
    for (let i = 0; i != data.polozky.length; i++){
      this.vysec = data.polozky[i];
      //this.popisek = this.vysec.popisek;
      this.startVysec = this.soucetVyseci/this.soucetHodnot * 2 * Math.PI;
      this.konecVysec = (this.soucetVyseci + this.vysec.hodnota)/this.soucetHodnot * 2 * Math.PI;
      //alert(this.vysec.popisek+": "+this.vysec.hodnota);
      //alert(data.polozky[0].popisek+": "+data.polozky[0].hodnota);
      this.vykresliVysece();
      //this.vykresliPopisky();
      this.vytvorSeznamy(this.vysec.popisek, data.polozky, i, this.typ_pr);
      this.soucetVyseci += this.vysec.hodnota;
    }
    this.vykresliNadpis("Předměty ve škole");
    this.vytvorLegendu(data.polozky,this.ukazLegendu,this.typ_pr);
  }

  vykresliObraz(divId, imgId){
    this.url = this.elementPlatna.toDataURL();
    this.obrazek = document.createElement("img");
    document.getElementById(divId).appendChild(this.obrazek);
    this.obrazek.src = this.url;
    this.obrazek.id = imgId;
  }

  smazObraz(imgId){
    this.obrazek = document.getElementById(imgId);
    return this.obrazek.parentNode.removeChild(this.obrazek);
  }
}

class Data {
  constructor(minNahod, maxNahod) /*(hodnota1, hodnota2, hodnota3, hodnota4)*/ {
    this.min = minNahod;
    this.max = maxNahod;
    this.nahodna = function() {
      return Math.floor(Math.random() * this.max) + this.min;
    };

    this.pole = [];
    this.nahodnaJedinecna = function(){
      while(this.pole.length < 4){
        this.nahodnaH = this.nahodna();
        if(this.pole.indexOf(this.nahodnaH) > -1) continue;
        return this.pole[this.pole.length] = this.nahodnaH;
      }
    };
    //console.log(this.pole);
    /*this.hodnota1 = this.nahodna();
    this.hodnota2 = this.nahodna();
    this.hodnota3 = this.nahodna();
    this.hodnota4 = this.nahodna();*/
    this.barvy = ['#fde23e', '#57d9ff','#f16e23','#937e88'];
    /*this.barvy2= ['##fcfe04', '#640264', '#fc9a04', '#040264', '#fc6605','#04329c', '#fc3204', '#046664', '#cc0204', '#349905', '#9c0264', '#6ac330'];*/

    this.velikostPoleBarev = this.barvy.length;
    while (this.velikostPoleBarev > 0) {
        this.index = Math.floor(Math.random() * this.velikostPoleBarev);
        this.velikostPoleBarev--;
        this.temp = this.barvy[this.velikostPoleBarev];
        this.barvy[this.velikostPoleBarev] = this.barvy[this.index];
        this.barvy[this.index] = this.temp;
    }


    this.polozky = [
      {
        hodnota: this.nahodnaJedinecna(),//this.nahodna(),//this.hodnota1,
        popisek: 'Matematika',
        barva:   this.barvy[0]
      },
      {
        hodnota: this.nahodnaJedinecna(),//this.nahodna(),//this.hodnota3,
        popisek: 'Český jazyk',
        barva:   this.barvy[1]
      },
      {
        hodnota: this.nahodnaJedinecna(),//this.nahodna(),//this.hodnota2,
        popisek: 'Přírodopis',
        barva:   this.barvy[2]
      },
      {
        hodnota: this.nahodnaJedinecna(),//this.nahodna(),//this.hodnota4,
        popisek: 'Tělocvik',
        barva:   this.barvy[3]
      }
    ];
  }
  vypisZadani(iterace, predmetId, id_zadani){
    this.predmet = document.getElementById(predmetId+""+id_zadani);
    this.hodina = this.polozky[iterace].hodnota;
    this.predmet.setAttribute("data-value",this.hodina);
    switch(this.hodina){
      case 1:
        this.predmet.innerHTML = this.hodina+" hodinu";
      break;
      case ((this.hodina > 1 && this.hodina < 5)?this.hodina:2):
        this.predmet.innerHTML = this.hodina+" hodiny";
      break;
      case ((this.hodina >= 5)?this.hodina:5):
        this.predmet.innerHTML = this.hodina+" hodin";
      break;
    }
  }

  vypisSumaHodin(sumaId,id_zadani){
    this.suma = 0;
    this.sumaHodin = document.getElementById(sumaId+""+id_zadani);
    for (let i = 0; i != this.polozky.length; i++){
      this.suma = this.suma + this.polozky[i].hodnota;
    }
    switch(this.suma){
      case 1:
        this.sumaHodin.innerHTML = this.suma+" vyučovací hodinu";
      break;
      case ((this.suma > 1 && this.suma < 5)?this.suma:2):
        this.sumaHodin.innerHTML = this.suma+" vyučovací hodiny";
      break;
      case ((this.suma >= 5)?this.suma:5):
        this.sumaHodin.innerHTML = this.suma+" vyučovacích hodin";
      break;
    }
  }

  seznamySpravne(idZadani, idGrafSeznam){
    this.pocetSpravnych = 0;
    this.hodnotaZadani = document.getElementById(idZadani).getAttribute("data-value");
    this.hodnotaSeznamu = document.getElementById(idGrafSeznam).value;
    if(this.hodnotaSeznamu == this.hodnotaZadani) {this.pocetSpravnych++; return this.pocetSpravnych;} else {return this.pocetSpravnych=this.pocetSpravnych;};
  }

  seznamySpatne(idZadani, idGrafSeznam){
    this.pocetSpatnych = 0;
    this.hodnotaZadani = document.getElementById(idZadani).getAttribute("data-value");
    this.hodnotaSeznamu = document.getElementById(idGrafSeznam).value;
      if(this.hodnotaSeznamu != this.hodnotaZadani) {this.pocetSpatnych++; return this.pocetSpatnych;} else {return this.pocetSpatnych = this.pocetSpatnych;};
  }

  legendaSpravne(idLegenda, iterace){
    this.pocetSpravnych = 0;
    this.polozkaLegendy = document.getElementById(idLegenda).getElementsByTagName("div");
    this.hodnotaPolozky = this.polozkaLegendy[iterace*2].getAttribute("data-value");
    this.seznamLegendy = document.getElementById(idLegenda).getElementsByTagName("select");
    this.hodnotaSeznamu = this.seznamLegendy[iterace].value;
    if(this.hodnotaSeznamu == this.hodnotaPolozky) {this.pocetSpravnych++; return this.pocetSpravnych;} else {return this.pocetSpravnych = this.pocetSpravnych;};
  }

  legendaSpatne(idLegenda, iterace){
    this.pocetSpatnych = 0;
    this.polozkaLegendy = document.getElementById(idLegenda).getElementsByTagName("div");
    this.hodnotaPolozky = this.polozkaLegendy[iterace*2].getAttribute("data-value");
    this.seznamLegendy = document.getElementById(idLegenda).getElementsByTagName("select");
    this.hodnotaSeznamu = this.seznamLegendy[iterace].value;
    if(this.hodnotaSeznamu != this.hodnotaPolozky) {this.pocetSpatnych++; return this.pocetSpatnych;} else {return this.pocetSpatnych = this.pocetSpatnych;};
  }
}

class Hlavni {
  constructor(id_graf, id_platno,legenda, typ_pr) {
    /*const tvary = new Platno('graf', 'platno', 500, 400);

    tvary.vykresliCaru(50,50,150,150);
    tvary.vykresliKrivku(100, Math.PI/2, Math.PI*2);
    tvary.vykresliVysec(100, Math.PI/2, Math.PI*2, '#ff0000');*/
    
    //vycistim "platno"
    var obal = document.getElementById(id_graf);
    obal.innerHTML = '';
    let canvas = document.createElement('canvas');
    canvas.id = id_platno;
    obal.appendChild(canvas);

    const graf = new KruhovyGraf(id_graf, id_platno, 600, 400, 200, legenda, typ_pr);
    this.graf = graf;
    this.graf.vykresli(1,5,typ_pr);
  /*graf.smazObraz('obrazek');
    graf.vykresliObraz('kontejner','obrazek');
    tvary.skryjPlatno();*/
  }
}
class Kontrola {
  constructor(idZadani,typ_pr){
    this.data = new Data(1,5);
    this.typ_pr = typ_pr;
    this.zadani = document.getElementById(idZadani);
    this.predmety = this.zadani.getElementsByTagName("a");
  }
  kontrolaSeznamyGrafu(){
    this.pocetSpravnych = 0;
    this.pocetSpatnych = 0;
    for (let i = 0; i != this.data.polozky.length; i++){
      this.pocetSpravnych = this.pocetSpravnych + this.data.seznamySpravne(this.predmety[i].id, this.data.polozky[i].popisek+""+this.typ_pr);
      this.pocetSpatnych = this.pocetSpatnych + this.data.seznamySpatne(this.predmety[i].id, this.data.polozky[i].popisek+""+this.typ_pr);
    }
    switch(this.pocetSpravnych){
      case 0:
        print_modal("modal","chyba","Do grafu je nutné dosadit jenom ty správné hodnoty.");
        //alert("Do grafu je nutné dosadit jenom ty správné hodnoty.");
      break;
      case this.data.polozky.length:
        print_modal("modal","ok", "Gratuluji, do grafu byly dosazeny správné hodnoty.");
        //alert("Gratuluji, do grafu byly dosazeny správné hodnoty.");
      break;
      default :
        print_modal("modal","neutr","Počet hodnot správně dosazených do grafu: "+this.pocetSpravnych+".<br>Počet hodnot, které je nutné doplnit nebo opravit: "+this.pocetSpatnych+".");
        //alert("Počet hodnot správně dosazených do grafu: "+this.pocetSpravnych+".\nPočet hodnot, které je nutné doplnit nebo opravit: "+this.pocetSpatnych+".");
      break;
    }
  }

  kontrolaLegenda(){
    this.pocetSpravnych = 0;
    this.pocetSpatnych = 0;
    for (let i = 0; i != this.data.polozky.length; i++){
      this.pocetSpravnych = this.pocetSpravnych + this.data.legendaSpravne("leg"+this.typ_pr, i);
      this.pocetSpatnych = this.pocetSpatnych + this.data.legendaSpatne("leg"+this.typ_pr, i);
    }
    //this.pocetSpatnych = this.data.polozky.length - this.pocetSpravnych;
     switch(this.pocetSpravnych){
      case 0:
        print_modal("modal","chyba","Do legendy musíš správně přiřadit údaje.");
        //alert("Do legendy je nutné vybrat jenom ty správné hodnoty.");
      break;
      case this.data.polozky.length:  
        print_modal("modal","ok");
      break;
      default : 
         print_modal("modal", "neutr", "Počet hodnot správně dosazených do legendy: " + this.pocetSpravnych +".<br>Počet hodnot, které je nutné doplnit nebo opravit: "+this.pocetSpatnych+".");
        //alert("Počet hodnot správně dosazených do legendy: "+this.pocetSpravnych+".\nPočet hodnot, které je nutné doplnit nebo opravit: "+this.pocetSpatnych+".");
      break;
    }
  }
}




const spust = new Hlavni('graf_1','platno_1',true,1); 
const spust_2 = new Hlavni('graf_2','platno_2',false,2);

var zalozky = document.getElementsByClassName('tabs');
for(let i = 1; i<zalozky.length;i++)
  zalozky[i].classList.add('w3-hide');
  
document.getElementById('but_pr1').addEventListener("click", function(){
    let kontrola = new Kontrola('zadani_1',1); 
    kontrola.kontrolaSeznamyGrafu()
});

document.getElementById('but_pr2_a').addEventListener("click", function(){
    let kontrola2 = new Kontrola('zadani_2',2); 
    kontrola2.kontrolaSeznamyGrafu();
});

document.getElementById('but_pr2_b').addEventListener("click", function(){
    let kontrola3 = new Kontrola('zadani_2',2); 
    kontrola3.kontrolaLegenda();
});